Index: palm/trunk/SOURCE/chem_modules.f90
===================================================================
--- palm/trunk/SOURCE/chem_modules.f90	(revision 3297)
+++ palm/trunk/SOURCE/chem_modules.f90	(revision 3298)
@@ -15,7 +15,7 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2018 Leibniz Universitaet Hannover
-! Copyright 2017-2018 Karlsruhe Institute of Technology
-! Copyright 2017-2018 Freie Universitaet Berlin
+! Copyright 2018-2018 Leibniz Universitaet Hannover
+! Copyright 2018-2018 Karlsruhe Institute of Technology
+! Copyright 2018-2018 Freie Universitaet Berlin
 !------------------------------------------------------------------------------!
 !
@@ -27,7 +27,11 @@
 ! -----------------
 ! $Id$
-! Removed preprocessor directive __chem
+! - Minor formatting
+! - Introduced Variables for Chemistry emissions Module (Russo)
+! - Variables and parameters added for 2d and profile output (basit)
+! - Converted scalar  emission factors  to 1-D array of 99 elements each (basit)
+! - Removed "__chem" directive (basit)
 ! 
-! 2718 2018-01-02 08:49:38Z maronga
+! 3282 2018-09-27 10:49:12Z basit
 ! Initial revision
 !
@@ -49,7 +53,14 @@
  MODULE chem_modules
 
-    USE kinds 
     USE chem_gasphase_mod,                                                     &   
         ONLY: nspec, nvar, spc_names
+
+    USE control_parameters,                                                    &
+        ONLY: varnamelength
+
+    USE kinds
+
+    USE statistics,                                                            &
+        ONLY: pr_palm
 
 
@@ -60,76 +71,95 @@
     PUBLIC spc_names
 
-    LOGICAL ::  constant_top_csflux(99)            = .TRUE.                       !< chem spcs at the top  orig .TRUE.
-    LOGICAL ::  constant_csflux(99)                = .TRUE.                       !< chem spcs at namelist parameter   orig TRUE
+    INTEGER(iwp), DIMENSION(99)  :: cs_pr_index            = 0
+    INTEGER(iwp)  :: ibc_cs_b                                                      !< integer flag for bc_cs_b
+    INTEGER(iwp)  :: ibc_cs_t                                                      !< integer flag for bc_cs_t
+    INTEGER(iwp)  :: cs_pr_count                           = 0 
+    INTEGER(iwp)  :: max_pr_cs                             = 0
+    INTEGER(iwp)  :: cs_vertical_gradient_level_ind(99,10) = -9999                 !< grid index values of cs_vertical_gradient_level_ind(s)
+
+    LOGICAL       :: constant_top_csflux(99)               = .TRUE.                !< chem spcs at the top  orig .TRUE.
+    LOGICAL       :: constant_csflux(99)                   = .TRUE.                !< chem spcs at namelist parameter   orig TRUE
+    LOGICAL       :: call_chem_at_all_substeps             = .FALSE.               !< namelist parameter 
+    LOGICAL       :: chem_debug0                           = .FALSE.               !< namelist parameter flag for minimum print output
+    LOGICAL       :: chem_debug1                           = .FALSE.               !< namelist parameter flag for print output
+    LOGICAL       :: chem_debug2                           = .FALSE.               !< namelist parameter flag for further print output
+    LOGICAL       :: chem_gasphase_on                      = .TRUE.                !< namelist parameter 
+    LOGICAL       :: emission_output_required              = .TRUE.                !< Logical Variable for requiring Emission Outputs
+    LOGICAL       :: do_emis                               = .FALSE.               !< Flag for turning on chemistry emissions 
+    LOGICAL       :: cs_pr_namelist_found                  = .FALSE.               !< Namelist parameter: Names of t
 
 
-    INTEGER(iwp) :: cs_vertical_gradient_level_ind(99,10) = -9999                 !< grid index values of cs_vertical_gradient_level_ind(s)
-    REAL(wp),     DIMENSION(:),   ALLOCATABLE :: bc_cs_t_val
-    INTEGER(iwp)                              :: ibc_cs_b                         !< integer flag for bc_cs_b
-    INTEGER(iwp)                              :: ibc_cs_t                         !< integer flag for bc_cs_t
-
-    REAL(wp),      DIMENSION(:),  ALLOCATABLE ::  css                             !< scaling parameter for chem spcs
 
 !-- Namelist parameters for creating initial chemistry profiles
-    CHARACTER (LEN=20)               :: bc_cs_b    = 'dirichlet'                  !< namelist parameter
-    CHARACTER (LEN=20)               :: bc_cs_t    = 'initial_gradient'           !< namelist parameter
-    REAL(wp) :: wall_csflux (99,0:5)               = 0.0_wp                       !< namelist parameter
-    REAL(wp) :: cs_vertical_gradient (99,10)       = 0.0_wp                       !< namelist parameter
-    REAL(wp) :: cs_vertical_gradient_level (99,10) = -999999.9_wp                 !< namelist parameter
-    REAL(wp) :: top_csflux ( 99 )                  = 0.0_wp                       !< namelist parameter 
-    REAL(wp) :: cs_surface_initial_change(99)      = 0.0_wp                       !< namelist parameter
-    REAL(wp) :: surface_csflux(99 )                = 0.0_wp                       !< namelist parameter: fluxes where 'surface_csflux_name' is in the namelist
-!   RFo: I do not know whether it makes sense to have 'constant_csflux=.TRUE. for only these species where 
-!        no flux is given in the namelist. Let's choos surface_csflux=0.0 (and thus 'constant_csflux'=.TRUE.) as default
-!       To obtain  constant_csflux=.FALSE., set surface_csflux = 9999999.9 in the namelist
-!   @todo: need to think a bit more about constant_csflux for chemistry. 
+    REAL(wp) :: wall_csflux (99,0:5)               = 0.0_wp                        !< namelist parameter
+    REAL(wp) :: cs_vertical_gradient (99,10)       = 0.0_wp                        !< namelist parameter
+    REAL(wp) :: cs_vertical_gradient_level (99,10) = -999999.9_wp                  !< namelist parameter
+    REAL(wp) :: top_csflux ( 99 )                  = 0.0_wp                        !< namelist parameter 
+    REAL(wp) :: cs_surface_initial_change(99)      = 0.0_wp                        !< namelist parameter
+    REAL(wp) :: surface_csflux(99 )                = 0.0_wp                        !< namelist parameter: fluxes where 'surface_csflux_name' is in the namelist
 
-    LOGICAL :: call_chem_at_all_substeps           = .FALSE.                      !< namelist parameter 
-    LOGICAL :: chem_debug0                         = .FALSE.                      !< namelist parameter flag for minimum print output
-    LOGICAL :: chem_debug1                         = .FALSE.                      !< namelist parameter flag for print output
-    LOGICAL :: chem_debug2                         = .FALSE.                      !< namelist parameter flag for further print output
-    LOGICAL :: chem_gasphase_on                    = .TRUE.                       !< namelist parameter 
+    REAL(wp), DIMENSION(:),  ALLOCATABLE              :: bc_cs_t_val
+    REAL(wp), DIMENSION(:),  ALLOCATABLE              ::  css                      !< scaling parameter for chem spcs
+    REAL(wp), DIMENSION(99)                           :: cs_surface = 0.0_wp       !< Namelist parameter: Surface conc of chem spcs'
+    REAL(wp), DIMENSION(99,100)                       :: cs_heights = 9999999.9_wp !< Namelist parameter: Height lvls(m) for cs_profiles
+    REAL(wp), DIMENSION(99,100)                       :: cs_profile = 9999999.9_wp !< Namelist parameter: Chem conc for each spcs defined
 
-    CHARACTER (LEN=11), DIMENSION(99)         :: cs_name = 'novalue'              !< Namelist parameter: chem spcs names 
-    CHARACTER (LEN=11), DIMENSION(99)         :: cs_profile_name = 'novalue'      !< Namelist parameter: Names of the
-    CHARACTER (LEN=11), DIMENSION(99)         :: surface_csflux_name = 'novalue'  !< Namelist parameter: chem species surface fluxes names
-                                                                                  !< active chem spcs, default is 'novalue')  ????
-    REAL(wp), DIMENSION(99)                   :: cs_surface = 0.0_wp              !< Namelist parameter: Surface conc of chem spcs'
-    REAL(wp), DIMENSION(99,100)               :: cs_heights = 9999999.9_wp        !< Namelist parameter: Height lvls(m) for cs_profiles
-    REAL(wp), DIMENSION(99,100)               :: cs_profile = 9999999.9_wp        !< Namelist parameter: Chem conc for each spcs defined
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: cs                       !< chem spcs
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: cs_p                     !< prognostic value of chem spc
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: tcs_m                    !< weighted tendency of s for previous sub-timestep (Runge-Kutta)
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: cs                        !< chem spcs
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: cs_p                      !< prognostic value of chem spc
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET   :: tcs_m                     !< weighted tendency of cs for previous sub-timestep (Runge-Kutta)
 
 #else                                                               
 ! use pointers cs, cs_p and tcs_m to point arrays cs_1, cs_2, and cs_3
-    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_1                     !< pointer for swapping of timelevels for respective quantity
-    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_2                     !< pointer for swapping of timelevels for respective quantity
-    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_3                     !< pointer for swapping of timelevels for respective quantity
-
-    REAL(wp), DIMENSION(:,:,:), POINTER               :: cs                       !< pointer: sgs chem spcs)
-    REAL(wp), DIMENSION(:,:,:), POINTER               :: cs_p                     !< pointer: prognostic value of sgs chem spcs 
-    REAL(wp), DIMENSION(:,:,:), POINTER               :: tcs_m                    !< pointer:
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_1                      !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_2                      !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, TARGET :: cs_3                      !< pointer for swapping of timelevels for respective quantity
+    REAL(wp), DIMENSION(:,:,:), POINTER               :: cs                        !< pointer: sgs chem spcs)
+    REAL(wp), DIMENSION(:,:,:), POINTER               :: cs_p                      !< pointer: prognostic value of sgs chem spcs 
+    REAL(wp), DIMENSION(:,:,:), POINTER               :: tcs_m                     !< pointer:
 
 #endif                                                                            
-                                                                                  !< by cs_name for each height lvls defined by cs_heights
+ 
+    CHARACTER (LEN=20)                 :: bc_cs_b             = 'dirichlet'        !< namelist parameter
+    CHARACTER (LEN=20)                 :: bc_cs_t             = 'initial_gradient' !< namelist parameter
+    CHARACTER (LEN=11), DIMENSION(99)  :: cs_name             = 'novalue'          !< Namelist parameter: chem spcs names 
+    CHARACTER (LEN=11), DIMENSION(99)  :: cs_profile_name     = 'novalue'          !< Namelist parameter: Names of the chem for profiles
+    CHARACTER (LEN=11), DIMENSION(99)  :: surface_csflux_name = 'novalue'          !< Namelist parameter: chem species surface fluxes names
+                                                                                   !< active chem spcs, default is 'novalue')  ????
+    CHARACTER (LEN=80)                 :: mode_emis           ='PARAMETERIZED'     !< Mode of chemistry emissions: DEFAULT .OR. EXPERT .OR. 
+                                                                                   !  PARAMETERIZED
+    CHARACTER (LEN=80)                 :: time_fac_type       ='MDH'               !< Type of time treatment in the emis DEFAULT mode: HOUR .OR. MDH 
+    CHARACTER (LEN=80)                 :: daytype_mdh         ='workday'           !< Type of day in the MDH case: workday, weekend, holiday
+    CHARACTER (LEN=11), DIMENSION(99)  :: data_output_pr_cs   = 'novalue'          !< Namelist parameter: Names of the che    m for profile output
+                                                                                   !< by cs_name for each height lvls defined by cs_heights
 !
 !-- Namelist parameters for chem_emissions
     INTEGER(iwp) ::  main_street_id = 0
-    INTEGER(iwp) ::  max_street_id = 0
+    INTEGER(iwp) ::  max_street_id  = 0
     INTEGER(iwp) ::  side_street_id = 0
 !
 !-- Constant emission factors
-    REAL(wp) ::  emiss_factor_main = 0.0_wp
-    REAL(wp) ::  emiss_factor_side = 0.0_wp
+    REAL(wp) ::  emiss_factor_main ( 99 ) = -9999.0_wp
+    REAL(wp) ::  emiss_factor_side ( 99 ) = -9999.0_wp
     
-!-- Emission factors with daily cycle
-!     REAL(wp), DIMENSION(1:24) ::  emiss_factor_main = 0.0_wp
-!     REAL(wp), DIMENSION(1:24) ::  emiss_factor_side = 0.0_wp
+!-- Other Emissions Variables
+    INTEGER(iwp) ::  nspec_out                                                     !< Output of routine chem_emis_matching with 
+                                                                                   !< number of matched species
+    REAL(wp),ALLOCATABLE, DIMENSION(:,:,:,:)         :: emis_distribution          !> Emissions Final Values (main module output)
+
+    INTEGER(iwp),ALLOCATABLE,DIMENSION(:)            :: match_spec_input           !< Index of Input chem species for matching routine 
+    INTEGER(iwp),ALLOCATABLE,DIMENSION(:)            :: match_spec_model           !< Index of Model chem species for matching routine
+    INTEGER(iwp),ALLOCATABLE,DIMENSION(:)            :: match_spec_voc_input       !< index of VOC input components matching the model's VOCs
+    INTEGER(iwp),ALLOCATABLE,DIMENSION(:)            :: match_spec_voc_model       !< index of VOC model species matching the input VOCs comp.
+    INTEGER(iwp),DIMENSION(:)                        :: match_spec_pm(1:3)         !< results of matching the input and model's PMs
+    INTEGER(iwp),DIMENSION(:)                        :: match_spec_nox(1:2)        !< results of matching the input and model's NOx
+    INTEGER(iwp),DIMENSION(:)                        :: match_spec_sox(1:2)        !< results of matching the input and model's SOx! 
+                                                                                   ! TBD: evaluate whether to make them allocatable 
+                                                                                   ! and allocate their dimension in the matching 
+                                                                                   ! routine according to the number of components 
+                                                                                   ! matching between the model and the input files
 
     SAVE
-
  END MODULE chem_modules
 
Index: palm/trunk/SOURCE/chem_photolysis_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_photolysis_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/chem_photolysis_mod.f90	(revision 3298)
@@ -15,6 +15,6 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2018 Leibniz Universitaet Hannover
-! Copyright 2017-2018 Karlsruhe Institute of Technology
+! Copyright 2018-2018 Leibniz Universitaet Hannover
+! Copyright 2018-2018 Karlsruhe Institute of Technology
 !------------------------------------------------------------------------------!
 !
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Moved USE radiation_model_mod from MODULE section into Subroutine
+! in order to use constant photolysis without radiation module (forkel)
+! 
+! 3287 2018-09-28 10:19:58Z forkel
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -50,9 +54,6 @@
  MODULE chem_photolysis_mod
 
-    USE arrays_3d,                                                             &
-        ONLY:  dzw, hyp, pt, q, ql, zu, zw
-
-    USE basic_constants_and_equations_mod,                                     &
-        ONLY:  pi
+!   USE arrays_3d,                                                             &
+!       ONLY:  dzw, q, ql, zu, zw
 
     USE control_parameters,                                                    &
@@ -64,14 +65,6 @@
         ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
 
-    USE radiation_model_mod,                                                   &
-        ONLY:  calc_zenith, zenith
-               !day, day_init, lat, lambda, lon,                   &
-               !time_utc, time_utc_init,    !FKa: This is now handled by date_and_time_mod
-
     USE control_parameters,                                                    &
         ONLY:  initializing_actions           
-!       ONLY:  cloud_droplets, initializing_actions,                           &
-!              large_scale_forcing, lsf_surf, phi, pt_surface, rho_surface,    &
-!              surface_pressure, time_since_reference_point
 
     USE chem_gasphase_mod,                                                     &
@@ -84,7 +77,4 @@
         ONLY: chem_debug2
 
-!   REAL(wp), DIMENSION(0:0) ::  zenith,         & !< cosine of solar zenith angle
-!                                sun_dir_lat,    & !< solar directional vector in latitudes
-!                                sun_dir_lon       !< solar directional vector in longitudes
     USE kinds
 
@@ -106,20 +96,20 @@
 
 !-- Parameters for constant photolysis frequencies
-     INTEGER,PARAMETER :: nconst  = 15               !< available predefined photolysis prequencies for constant 
+    INTEGER,PARAMETER :: nconst  = 15               !< available predefined photolysis prequencies for constant 
 
 ! Names for predefined fixed photolysis frequencies at zenith angle 0
-     CHARACTER(LEN=10), PARAMETER, DIMENSION(nconst) :: names_c =  (/                    &
+    CHARACTER(LEN=10), PARAMETER, DIMENSION(nconst) :: names_c =  (/                    &
                      'J_O31D    ','J_O33P    ','J_NO2     ','J_HNO3    ','J_RCHO    ', &
                      'J         ','J         ','J         ','J         ','J         ', &
                      'J         ','J         ','J         ','J         ','J         ' /)
 ! Photolysis frequency at zenith angle 0 in 1/s
-     REAL(wp), PARAMETER, DIMENSION(nconst) :: phot0 =  (/                             &
-                     2.489E-05_wp,3.556E-04_wp, 8.89E-03_wp,5.334E-07_wp,3.734E-05_wp, &
-                     0.0000E00_wp,0.0000E00_wp,0.0000E00_wp,0.0000E00_wp,0.0000E00_wp, &
-                     0.0000E00_wp,0.0000E00_wp,0.0000E00_wp,0.0000E00_wp,0.0000E00_wp /)
+    REAL(wp), PARAMETER, DIMENSION(nconst) :: phot0 =  (/                             &
+                      2.489E-05_wp,3.556E-04_wp, 8.89E-03_wp,5.334E-07_wp,3.734E-05_wp, &
+                      0.0000E00_wp,0.0000E00_wp,0.0000E00_wp,0.0000E00_wp,0.0000E00_wp, &
+                      0.0000E00_wp,0.0000E00_wp,0.0000E00_wp,0.0000E00_wp,0.0000E00_wp /)
 
 
 !-- Parameters for simple photolysis frequencies
-     INTEGER,PARAMETER :: nsimple = 15               !< available predefined photolysis prequencies for simpel parameterisation
+    INTEGER,PARAMETER :: nsimple = 15               !< available predefined photolysis prequencies for simpel parameterisation
 ! Names for simple photolysis frequencies parameterisation (
      CHARACTER(LEN=10), PARAMETER, DIMENSION(nsimple) :: names_s =  (/                 &
@@ -146,18 +136,11 @@
 
 
-!    REAL(wp) :: time_photolysis = 0.0_wp,         & !< time since last call of photolysis code
-!                dt_photolysis = 0.0_wp,           & !< hotolysis model timestep
-!                skip_time_do_photolysis = 0.0_wp    !< Radiation model is not called before this time
+    REAL(wp) :: time_photolysis = 0.0_wp,         & !< time since last call of photolysis code
+                dt_photolysis = 0.0_wp,           & !< hotolysis model timestep
+                skip_time_do_photolysis = 0.0_wp    !< Radiation model is not called before this time
 
     REAL(wp)     :: cosz = 0.7_wp                   !< cosine of Zenith angle (45 deg, if not specified otherwise)
 
 !
-!-- Variables and parameters used in Fast-J only
-! ....
-
-!   INTERFACE photolysis_check_parameters
-!      MODULE PROCEDURE photolysis_check_parameters
-!   END INTERFACE photolysis_check_parameters
-  
     INTERFACE photolysis_constant
        MODULE PROCEDURE photolysis_constant
@@ -176,23 +159,4 @@
     END INTERFACE photolysis_control
 
-!   INTERFACE photolysis_header
-!      MODULE PROCEDURE photolysis_header
-!   END INTERFACE photolysis_header 
-! 
-    INTERFACE photolysis_init
-       MODULE PROCEDURE photolysis_init
-    END INTERFACE photolysis_init
-
-!   INTERFACE photolysis_parin
-!      MODULE PROCEDURE photolysis_parin
-!   END INTERFACE photolysis_parin
-    
-!   INTERFACE photolysis_read_restart_data
-!      MODULE PROCEDURE photolysis_read_restart_data
-!   END INTERFACE photolysis_read_restart_data
-
-!   INTERFACE photolysis_last_actions
-!      MODULE PROCEDURE photolysis_last_actions
-!   END INTERFACE photolysis_last_actions
 
     SAVE
@@ -200,15 +164,7 @@
     PRIVATE
 
-!
-!-- Public functions / NEEDS SORTING
-!   PUBLIC photolysis_init
-!          photolysis_check_parameters, photolysis_control,                      &
-!          photolysis_header, photolysis_init, photolysis_parin !,                 &
-!          photolysis_define_netcdf_grid, photolysis_last_actions,               &
-!          photolysis_read_restart_data, photolysis_data_output_mask
-
-   PUBLIC  photolysis_control, photolysis_init
-
-   PUBLIC  photolysis_scheme
+    PUBLIC  photolysis_control
+
+    PUBLIC  photolysis_scheme
 !
 
@@ -223,7 +179,5 @@
     SUBROUTINE photolysis_control
  
- 
        IMPLICIT NONE
-
 
        SELECT CASE ( TRIM( photolysis_scheme ) )
@@ -245,19 +199,4 @@
     END SUBROUTINE photolysis_control
 
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Initialization of the photolysis model
-!------------------------------------------------------------------------------!
-    SUBROUTINE photolysis_init    !### not yes used. Call should be placed near call of chem_init
-    
-       IMPLICIT NONE
-
-!-- Just in case we need anything
-
-       RETURN
-
-    END SUBROUTINE photolysis_init
-
 
 !------------------------------------------------------------------------------!
@@ -269,23 +208,15 @@
     SUBROUTINE photolysis_constant
 
-
        IMPLICIT NONE
 
-!      INTEGER(iwp) :: i, j, k   !< loop indices
        INTEGER(iwp) :: iphot,iav !< loop indix for photolysis reaction
-!      REAL(wp)     :: exn,   &  !< Exner functions at surface (better use palms own exner array in arrays_3d)
-!                      pt1       !< potential temperature at first grid level
 
        DO iphot = 1,nphot
           DO iav = 1,nconst
              IF ( TRIM( names_c(iav) ) == TRIM( phot_names(iphot) ) ) then
-!--    Prescribe fixed photolysis frequencies  [1/s]
-!             IF(myid == 0 .AND. chem_debug2 )  WRITE(06,*) iphot, iav,phot_names(iphot),names_c(iav)
-
-                      phot_frequen(iphot)%freq(nzb+1:nzt,:,:) =    &
-                            phot0(iav) * cosz
-
-!              IF(myid == 0 .AND. chem_debug2 )  WRITE(06,*) phot_frequen(iphot)%freq(1,5,5)
-            ENDIF
+!--             Prescribe fixed photolysis frequencies  [1/s]
+                phot_frequen(iphot)%freq(nzb+1:nzt,:,:) =    &
+                             phot0(iav) * cosz
+             ENDIF
           ENDDO
        ENDDO
@@ -303,35 +234,30 @@
     SUBROUTINE photolysis_simple
 
+       USE radiation_model_mod,                                                   &
+           ONLY:  calc_zenith, zenith
+
        IMPLICIT NONE
 
-!      INTEGER(iwp) :: i, j, k   !< loop indices
        INTEGER(iwp) :: iphot,iav !< loop indix for photolysis reaction
-!      REAL(wp)     :: exn,   &  !< Exner functions at surface (better use palms own exner array in arrays_3d)
-!                      pt1       !< potential temperature at first grid level
        REAL(wp)     :: coszi     !< 1./cosine of zenith angle
 
-    DO iphot = 1,nphot
-       phot_frequen(iphot)%freq = 0.0_wp
-    ENDDO
-
-    CALL calc_zenith
-
-    IF ( zenith(0) > 0.0_wp ) THEN
-       coszi = 1. / zenith(0)
-
        DO iphot = 1,nphot
-          DO iav = 1,nsimple
-             IF ( TRIM( names_s(iav) ) == TRIM( phot_names(iphot) ) ) then
-!              if(myid == 0 .AND. chem_debug2 )  WRITE(06,*) 'simple', iphot, iav,phot_names(iphot),names_s(iav)
-
-                      phot_frequen(iphot)%freq(nzb+1:nzt,:,:) =    &
-                            par_l(iav) * zenith(0)**par_m(iav) *  EXP( -par_n(iav) * coszi ) 
-
-!              if(myid == 0 .AND. chem_debug2 )  WRITE(06,*) 'simple', phot_frequen(iphot)%freq(1,5,5)
-            ENDIF
+          phot_frequen(iphot)%freq = 0.0_wp
+       ENDDO
+
+       CALL calc_zenith
+
+       IF ( zenith(0) > 0.0_wp ) THEN
+          coszi = 1. / zenith(0)
+
+          DO iphot = 1,nphot
+             DO iav = 1,nsimple
+                IF ( TRIM( names_s(iav) ) == TRIM( phot_names(iphot) ) ) then
+                   phot_frequen(iphot)%freq(nzb+1:nzt,:,:) =    &
+                                par_l(iav) * zenith(0)**par_m(iav) *  EXP( -par_n(iav) * coszi ) 
+                ENDIF
+             ENDDO
           ENDDO
-       ENDDO
-    ENDIF
-
+       ENDIF
     END SUBROUTINE photolysis_simple
 
